ChangeSubmitterDialog = (function () {
	
	var autocompleteCache = {};
	var errorFlag = false;
	var massiveMode = false;
	var items = null;
	
	function ChangeSubmitterDialog__mkNewDialog(submitterDialog, method) {
		$("#submitterModalMessage").remove();
		var dialog = j('#changeOwnerForm').modal();
		var form = dialog.find('from');
		j(form ).bootstrapValidator({
		    excluded: [':disabled', ':hidden', ':not(:visible)'],
		    live: 'enabled'
		});
		dialog.find("[data-action='cancel']").on('click', function() {
			dialog.modal('hide');
			autocompleteCache = {};
		});
		
		dialog.find("[data-action='ok']").on('click', function() {
			autocompleteCache = {};
			if (errorFlag && massiveMode) {
				activeButtonInModal();
				errorFlag = false;
				dialog.modal('hide');
				location.reload(true);
			}
			else {
				var formData = dialog.find('form').serializeArray();
				method.call(submitterDialog, formData, function() {
					dialog.modal('hide');

				}); 
				
				
			}
		});
		
		dialog.find("#newSubmitter").autocomplete({
			minLength: 2,
			source: function( request, response ) {
				var nSubMsg = j('#newSubmitterMsg');
				if(nSubMsg){
					nSubMsg.remove();
				}
				
				var term = request.term;
				if ( term in autocompleteCache ) {
					response( autocompleteCache[ term ] );
				} else {
					j('#newSubmitterFeedback').removeClass('hidden');
					j.ajax({
						"url": submitterDialog.getIrCtxPath()+"/json/chsubmitter/researchpage",
						"data": [{name:"name", value: term}],
						"dataType": "json",
						"method": "GET",
						"success": function (json) {
							j('#newSubmitterSpin').hide();
							
							var length = json.length;
							for(var i=0; i<length; i++) {
								var item = json[i];
								item.label = item.label.replace(/<[^>]*>/g," ");
								json[i] = item;
							}
							
							autocompleteCache[ term ] = json;
							response( json );
							j('#newSubmitterFeedback').addClass('hidden');
						},
						"error": function (json) {
							//alert('Error: '+json);
							var msg = json.responseText;
							if(json.responseJSON){
								msg  = json.responseJSON.msg;
							}
							showMessageInModal(msg, "alert-danger", "fa-exclamation-triangle");
						}
					});
				}
			},
			select: function( event, ui ) {
				dialog.find("input[name='newSubmitterId']").val(ui.item.id);
			}
		});
		
		return dialog;
	}
	
	function ChangeSubmitterDialog__updateForm(id, info) {
		$("#submitterModalMessage").remove();
		var form = j('#changeOwnerForm').find('form');
		
		//se id e info entrambi a null operazione massiva, non devo visualizzare info e Autori conosciuti
		if (id == null){
			//nascondo info e radio autori conosciuti
			$("#modal-info").hide();
			//$('#modal-title').hide();
			//$('#modal-year').hide();
			//$('#modal-authors').hide();
			//$('#modal-submitter').hide();
			if (info == null) {
				form.find(".ownerRadio .recognizedAuthor").hide();
			}
		} else {
			$("#modal-info").show();
			form.find(".ownerRadio .recognizedAuthor").show();
		}
		
		var infosEls = j('#changeOwnerForm').find('.info');
		for(var k in info) {
			infosEls.find('.'+k).html(info[k]);
		}	
		
		
		function showHideRelatedWidget(value) {
			if(value == 'currentUser') {
				var newSubmitter = form.find("input[name='newSubmitter']"); 
				newSubmitter.prop('disabled', true);
				newSubmitter.parents("div.form-group").hide();
				
				form.find("div.chown_recauths_list").parents("div.form-group").hide();
				
			} else if(value == 'otherUser') {
				var newSubmitter = form.find("input[name='newSubmitter']"); 
				newSubmitter.prop('disabled', false);
				newSubmitter.parents("div.form-group").show();
				
				form.find("div.chown_recauths_list").parents("div.form-group").hide();
			} else if(value == 'recognizedAuthor') {
				var newSubmitter = form.find("input[name='newSubmitter']"); 
				newSubmitter.prop('disabled', true);
				newSubmitter.parents("div.form-group").hide();
				
				form.find("div.chown_recauths_list").parents("div.form-group").show();
			}
		}
		
		function ensureWidgetCheck(value) {
			var radioToCheck = form.find("div.ownerRadio").find("input[value='"+value+"']:radio");
			radioToCheck.prop('checked', true);
		}
		
		
		if(info != null && info['ownerIsCurrentUser']) {
			form.find(".ownerRadio .currentUserAsSubmitter").hide();
			ensureWidgetCheck("recognizedAuthor");
			showHideRelatedWidget("recognizedAuthor");
		} else {
			form.find(".ownerRadio .currentUserAsSubmitter").show();
			ensureWidgetCheck("currentUser");
			showHideRelatedWidget("currentUser");
		}
		
		form.find(".ownerRadio input[type='radio']").on('change', function() {
			var el = j(this);
			if(el.prop('checked')) {
				var value = el.prop('value');
				showHideRelatedWidget(value);
			}
		});
		
		var radiosHtml = '';
		if (info != null) {
			for(var i=0; i<info.recognizedAuthors.length; i++) {
				var recognizedAuthor = info.recognizedAuthors[i];
				var oneRadio = '<label class="radio" for="recauthradios-'+i+'">'
					+ '<input type="radio" name="recauth" id="recauthradios-'+i+'" value="'
					+ recognizedAuthor.id
					+ '" />'
					+ '<div>'+recognizedAuthor.desc+'</div>'
					+ '</label>';
				radiosHtml = radiosHtml + oneRadio + "\n";
			}
		}
		
		form.find(".chown_recauths_list").html(radiosHtml);
		
		form.find("input[name='itemId']").val(id);
		form.find("input[name='newSubmitterId']").val("");
		form.find("input[name='newSubmitter']").val("");
	}
	
	function ChangeSubmitterDialog(irCtxPath, rmCtxPath) {
		$("#submitterModalMessage").remove();
		
		var _private = {
			irPath : irCtxPath,
			//rmPath : rmCtxPath,
			reload : false,
			//currentUserId : null,
			//currentUserDesc : null,
			dialog : null
		};
		
		this.getIrCtxPath = function ChangeSubmitterDialog__getIrCtxPath() {
			return _private.irPath;
		};
		
		this.setReload = function ChangeSubmitterDialog__setReload( reload) {
			if(typeof reload === 'boolean') {
				_private.reload = reload;
			} else {
				_private.reload = (reload == "true") ? true : false;
			}
		};
		
		/*
		this.setCurrentUserId = function ChangeSubmitterDialog__setCurrentUserId( currentUserId) {
			if(typeof currentUserId === 'string') {
				_private.currentUserId = currentUserId;
			} else {
				_private.currentUserId = null;
			}
		};
		
		this.setCurrentUserDesc = function ChangeSubmitterDialog__setCurrentUserDesc( currentUserDesc) {
			if(typeof currentUserDesc === 'string') {
				_private.currentUserDesc = currentUserDesc;
			} else {
				_private.currentUserDesc = null;
			}
		};
		*/
		
		this.openMassiveChange = function ChangeSubmitterDialog__openMassiveChange(listItem) {
			massiveMode = true;
			errorFlag = false;
			items = listItem;
			//var info = {title: "Titolo", authors: "Io lui noi", year: "1234", ownerIsCurrentUser: false, recognizedAuthors: [{id: "rp12345", desc: "Cognome, Nome"}],  submitter: "Cognome, Nome" };
			var info = null;
			var self = this;
			ChangeSubmitterDialog__updateForm(null, info);
			if(_private.dialog) {
				_private.dialog.modal("show");
			} else {
				_private.dialog = ChangeSubmitterDialog__mkNewDialog(self, self.executeFunction);
			}
		};
		
		this.open = function ChangeSubmitterDialog__open(id) {
			massiveMode = false;
			errorFlag = false;
			items = null;
			//var info = {title: "Titolo", authors: "Io lui noi", year: "1234", ownerIsCurrentUser: false, recognizedAuthors: [{id: "rp12345", desc: "Cognome, Nome"}],  submitter: "Cognome, Nome" };
			
			var self = this;
				j.ajax({
					"url": _private.irPath+"/json/chsubmitter/item-detail/"+id,
					"data" : [],
					"dataType": "json",
					"method": "GET",
					"success": function (json) {
						ChangeSubmitterDialog__updateForm(id, json);
						if(_private.dialog) {
							_private.dialog.modal("show");
						} else {
							_private.dialog = ChangeSubmitterDialog__mkNewDialog(self, self.executeFunction);
						}
					},
					"error": function (json) {
						//alert('Error: '+json);
						var msg = json.responseText;
						if(json.responseJSON){
							msg  = json.responseJSON.msg;
						}
						showMessageInModal(msg, "alert-danger", "fa-exclamation-triangle");
					}
			});
		};
		
		function mkFormDataFromObj(obj) {
			var formData = [];
			for(key in obj) {
				if(obj.hasOwnProperty(key)) {
					formData.push({ name: key , value: obj[key]});
				}
			}
			return formData;
		}
		
		this.executeFunction = function ChangeSubmitterDialog__executeFunction(formData, formCloser) {
			$("#submitterModalMessage").remove();
			
			var id = "NONE";
			var values = {};
			for(var i=0; i<formData.length; i++) {
				if(formData[i]) {
					if(formData[i].name) {
						values[""+formData[i].name] = formData[i].value;
					}
				}
			}
			//aggiungo lista oggetti vuota al json
			values["itemList"] = "";
			
			if (items !== null){
				values["itemList"] = items;
			}
			
			if(values.itemId) {
				id = values.itemId; 
			}
			
			if(values.newSubmitterType == 'recognizedAuthor') {
				values.newSubmitterType = 'otherUser';
				values.newSubmitterId = values.recauth;
			}
			
			if(values.newSubmitterType == 'otherUser' && (!values.newSubmitterId)) {
				var msg = j("#newSubmitter").attr("data-bv-notempty-message");
				//alert(msg);
				
				if(j('#newSubmitterMsg').length <= 0){
					j("#newSubmitterContainer").after(
						"<div id=\"newSubmitterMsg\" class=\"alert alert-warning alert-dismissible\" role=\"alert\"> <button type=\"button\" class=\"close\" data-dismiss=\"alert\"><span aria-hidden=\"true\">&times;</span><span class=\"sr-only\">Close</span></button>"
						 + msg+
						"</div>");
				}
				
			} else {
				if (id != "NONE"){
					var url = _private.irPath+"/json/chsubmitter/do/"+id;
				} else {
					var url = _private.irPath+"/json/chsubmitter/doAll/";
				}
				//se siamo in massiveMode spin di attesa 
				if (massiveMode){
					showMessageInModal("", "alert-success", "fa-spinner icon-spinner7 spin ");	
					disableButtonInModal();
				}
				
				
					j.ajax({
						"url": url,
						"data": mkFormDataFromObj(values),
						"dataType": "json",
						"method": "POST",
						"success": function (json) {
							if(massiveMode) {
								activeButtonInModal();
							}
							
							if(json && json.ok) {
								formCloser();
								if(_private.reload) {
									location.reload(true);
								}
							} else {
								alert('Error: '+json.msg);
							}
						},
						"error": function (json, textStatus, errorThrown ) {
							if(massiveMode) {
								$("#modal-ok").removeAttr('disabled');
								//activeButtonInModal();
								errorFlag = true;
							}
							var msg = '';
							msg = json.responseText;
							if(json.responseJSON){
								msg  = json.responseJSON.msg;
							}
							showMessageInModal(msg, "alert-danger", "fa-exclamation-triangle");
							//alert('Error: '+json.responseJSON.msg);
						}
					});
				} 
		};
	
		
	}
	
	function disableButtonInModal(){
		$("#modal-ok").attr('disabled','disabled');
		$("#modal-cancel").attr('disabled','disabled');
	}
	
	function activeButtonInModal(){
		$("#modal-ok").removeAttr('disabled');
		$("#modal-cancel").removeAttr('disabled');
	}
	
	function showMessageInModal (msg, alert, icon){
		//rimuovo messaggio precedente
		j('#submitterModalMessage').remove();
		j('#changeOwnerForm .modal-body').append(
				"<div id=\"submitterModalMessage\" class=\"alert " + alert + "\" role=\"alert\"> "
				+ "<span class=\"fa " +icon +"\" aria-hidden=\"true\"></span> "
				+ msg
				+ "</div>");
	}
	
	return ChangeSubmitterDialog;	
})();
