function splitContributors(contextPath, fieldName, fieldInput, labelButtonAdd, bshare, bintord, baffil)
{
	splitContributors(contextPath, fieldName, null, fieldInput, labelButtonAdd, 100, bshare, bintord, baffil);
}

function splitContributors(contextPath, fieldName, affiliationInput, fieldInput, labelButtonAdd, size, bshare, bintord, baffil)
{
	var values = j(fieldName).val();
	var affvalues = null;
	if (affiliationInput != null) {
		affvalues = j(affiliationInput).val();
	}
	j('#splitcontributorsprogress').modal("show");
	j.ajax({
		url: contextPath+"/json/contributors", 
		type: "POST",
		dataType: "json", 
		async: false,
		contentType: "application/x-www-form-urlencoded;charset=UTF-8", 
		data: ({md: fieldInput, allcontributors: values, allaffiliations: affvalues, showintord: bintord, showshare: bshare}), 
		error: function(info){j('#splitcontributorsprogress').modal("hide");},
		success: function(info) {
			j('#splitcontributorsprogress').modal("hide");
			if (info.errorMsg != null) {
				j("#insertinternalmanuallyerrordetail").html("<strong>"+info.errorMsg+"</strong>");
				j('#insertinternalmanuallyerror').modal("show");
				return;
			}
			if (info == null || info.allcontributors == '') {
				return;
			}			
			j("#"+fieldInput.replace("dc_authority_","dc_description_all")+"_id").val(info.allcontributors);
			j("#"+fieldInput.replace("dc_authority_","dc_description_all")+"_id").change();
			if(!info.searchInternal){
				j('#insertinternalmanually').modal("show");
			}else{
				info.contextPath = contextPath;
				j("#sharetbody_"+fieldInput).html(tmpl("tmpl-sharepriority-tbody", info));
				j("#sharetbody_"+fieldInput).find("button[name*='_remove']").on('click', function() {
					clientSideValidationButtonName = "remove";
				});
				j("#sharetable_"+fieldInput).effect('highlight',null,5000);
				j("#sharetable_"+fieldInput+"_detectinfo").remove();
				if (j("#sharetable_"+fieldInput+"_detectinfo").length == 0)
				{
					j("#sharetable_"+fieldInput).before(tmpl("tmpl-sharepriority-detect-info",{fieldName: fieldInput, shareAuthorInfos: info.shareAuthorInfos}));
				}
                var newId = info.shareAuthorInfos.length+1;
                var autocomplete = { metadataField: 'dc_authority_people', isClosed: 'false', 
                        inputName: "dc_authority_people_"+newId, authorityName: "dc_authority_people_authority_"+newId, 
                        containerID: "dc_authority_people_"+newId+"_autocomplete", indicatorID: "dc_authority_people_"+newId+"_indicator", 
                        contextPath: contextPath, confidenceName: "dc_authority_people_confidence_"+newId , 
                        confidenceIndicatorID: "dc_authority_people_"+newId+"_confidence_indicator_id", collection: -1 };                
                DSpaceSetupAutocomplete('edit_metadata',autocomplete);
			}
			for (var i = 1; i <= info.shareAuthorInfos.length; i++)
			{
				DSpaceSetupAutocomplete('edit_metadata',{ metadataField: 'dc_authority_people', isClosed: 'false', 
					inputName: fieldInput+'_'+i, authorityName: fieldInput+'_authority_'+i, 
					containerID: fieldInput+'_'+i+'_autocomplete', indicatorID: fieldInput+'_'+i+'_indicator', 
					contextPath: contextPath, confidenceName: fieldInput+'_confidence_'+i, 
					confidenceIndicatorID: fieldInput+'_'+i+'_confidence_indicator_id', collection: -1 });
                
				if (info.shareAuthorInfos[i-1].authors.length == 1 && 
						info.shareAuthorInfos[i-1].authors[0].authority != null && info.shareAuthorInfos[i-1].authors[0].authority != '')
                {
                 j.ajax({
                	 url:  contextPath+"/json/authorityDetails",
                	 async: false,
                	 data: {
                     field: 'dc_authority_people',
                     // Details only for the first authors recognized
                     key: info.shareAuthorInfos[i-1].authors[0].authority
                     },
                     success: function(data){
                      // tmpl-authority-details-RPAuthority 
                      j("#dc_authority_people_"+i+"_details").html(tmpl("tmpl-authority-details-RPAuthority", data.details));
                     }
                 });
                }
                else
                {
                 j("#dc_authority_people_"+i+"_details").html('');
                }

			    //j.scrollTo((j('#msgSplitFeature_'+fieldInput)));
		    }
			return;
		}
	  });
}

function fillContributor(fieldInput,fieldInputIndex,valueOption) {

	var substr = valueOption.split('_');
	var fullname = substr[0];
	var authority = substr[1]=="undefined"?"":substr[1];
	var dc_contributor_author = "#"+fieldInput+"_"+fieldInputIndex;
	j(dc_contributor_author).val(fullname);	
	var dc_contributor_author_authority = "#"+fieldInput+"_authority_"+fieldInputIndex;
	var dc_contributor_author_confidence = "#"+fieldInput+"_confidence_"+fieldInputIndex;
	var dc_contributor_author_confidence_indicator = "#"+fieldInput+"_"+fieldInputIndex+"_confidence_indicator_id";
	if (authority!="$")
	{
		updateAuthorityDetailsInfo(dspaceContextPath, fieldInput, fieldInput+"_"+fieldInputIndex, authority);
		j(dc_contributor_author_authority).val(authority);
		if (authority!=null)
		{
			j(dc_contributor_author_confidence).val('accepted');
			j(dc_contributor_author_confidence_indicator).addClass('fa-check');
			j(dc_contributor_author_confidence_indicator).removeClass('fa-question-circle');
			j(dc_contributor_author_confidence_indicator).addClass('text-success');
			j(dc_contributor_author_confidence_indicator).removeClass('text-warning');
		}
		else
		{
			j(dc_contributor_author_confidence).val('unset');
			j(dc_contributor_author_confidence_indicator).removeClass('fa-check');
			j(dc_contributor_author_confidence_indicator).removeClass('fa-question-circle');
			j(dc_contributor_author_confidence_indicator).removeClass('text-success');
			j(dc_contributor_author_confidence_indicator).removeClass('text-warning');
		}
	}
	else
	{
		updateAuthorityDetailsInfo(dspaceContextPath, fieldInput, fieldInput+"_"+fieldInputIndex, null);
		j(dc_contributor_author_authority).val('');
		j(dc_contributor_author_confidence).val('ambiguous');
		j(dc_contributor_author_confidence_indicator).removeClass('fa-check');
		j(dc_contributor_author_confidence_indicator).removeClass('text-success');
		j(dc_contributor_author_confidence_indicator).addClass('fa-question-circle');
		j(dc_contributor_author_confidence_indicator).addClass('text-warning');
	}
}

function populateAffiliations(fieldInput, fieldInputIndex, authorIdx)
{
	var input_affiliation = "#"+fieldInput+"_affiliation_"+fieldInputIndex;
	var select_affiliation = "#select_"+fieldInput+"_affiliation_"+fieldInputIndex;
	var authorinfo = j("#"+fieldInput+"_"+fieldInputIndex).data('authorsinfo');
	if (authorinfo != null && authorIdx < authorinfo.length)
	{
		var auth = authorinfo[authorIdx];
		var affiliations = auth.affiliations;
		if (affiliations == null || affiliations.length <= 1)
		{

			var top = j(select_affiliation).offset().top;
			var left = j(select_affiliation).offset().left;
			var swidth = j(select_affiliation).width();
			j(select_affiliation).hide();
			j(input_affiliation).show();
			var iwidth = j(input_affiliation).width();
			j(input_affiliation).offset({top: top, left: left+swidth-iwidth-4});
			if (affiliations != null && affiliations[0] != null)
			{
				j(input_affiliation).val(affiliations[0]);	
			}
			else
			{
				j(input_affiliation).val('');	
			}
		}
		else
		{
			var totaff = "";
			for (var i = 0; i < affiliations.length; i++)
			{
				if (i != 0)
				{
					totaff += "|||";
				}
				totaff += affiliations[i];
			}
			totaffhtml = totaff.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;");
			j(input_affiliation).val(totaff);
			j(input_affiliation).hide();
			j(select_affiliation).html('');
			j(select_affiliation).append('<option value="'+totaffhtml+'" selected="selected">'+SUROA_I18N_SHAREPRIORITYFEATURE_SELECT_AFF+'</option>');
			for (var i = 0; i < affiliations.length; i++)
			{
				var affhtml = affiliations[i].replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;");
				j(select_affiliation).append('<option value="'+affhtml+'">'+affhtml+'</option>');
			}
			j(select_affiliation).append('<option value="other">'+SUROA_I18N_SHAREPRIORITYFEATURE_OTHER_AFF+'</option>');
			j(select_affiliation).change(function(){fillAffiliation(this);});
		}
	}
}

function fillAffiliation(select){
	var val = j(select).val();
	var sid = '#'+j(select).attr('id').substring("select_".length);
	var selectid = '#'+j(select).attr('id');
	if ("other" == val)
	{
		var width = j(selectid).width();
		j(selectid).data('width', width);
		j(sid).val('');
		j(sid).show();
		j(sid).unbind('keydown');
		j(selectid).width('10em');
		j(sid).position({my: "left top", at: "right top", of: selectid});
		j(sid).width(width-6-j(selectid).width());
		j(sid).focus();
	}
	else
	{
		j(sid).hide();
		j(sid).val(val);
		j(selectid).width(j(selectid).data('width'));
	}
}

function recalculateShare(fieldName,basedOnNrAuthors) {
	var rows = j("table#sharetable_"+fieldName+" tbody tr");
	var count = j(rows).find("td:first input.ui-autocomplete-input").filter(function () {
	    return !!this.value;
	}).length;
	
	var data = j(rows).find("td:eq(1) input");
	var diffShare = 0;
	var intShare;
	var nrAuthorsInput;
	var nrAuthors;
	if(basedOnNrAuthors) {
		nrAuthorsInput = j("#dc_description_numberofauthors");
		if(nrAuthorsInput.length>0) {
			nrAuthors=nrAuthorsInput.val();
			intShare = Math.floor(100/nrAuthors);
			diffShare = 100-(nrAuthors*intShare);			
		}
		else basedOnNrAuthors=false;
	}
	if(!basedOnNrAuthors)
	{
		intShare = Math.floor(100/count);
		diffShare = 100-(count*intShare);		
	}

	
	j.each(data,function(index,value) {
		var firstInput = j("#"+fieldName+"_"+(index+1));
		var checkEmpty = jQuery.isEmptyObject(firstInput);
		if(!checkEmpty) {
			if(j(firstInput).val()) {
				j(value).val(intShare);					
				if(index<diffShare) {			
					j(value).val(intShare + 1);	
				}
			}
			else {
				j(value).val("");
			}
		}
	});
	
}

function recalculateIntOrder(fieldName) {
	var rows = j("table#sharetable_"+fieldName+" tbody tr");
	var data = j(rows).find("td:eq(2) input");
	var counter = 1;
	j.each(data,function(index,value){		
		var firstInput = j(value).parent().parent().children().get(0).firstChild;
		var checkEmpty = jQuery.isEmptyObject(firstInput);
		if(!checkEmpty) {
			if(j(firstInput).val().length>0) {			
				j(value).val(counter);
				counter++;
			}					
			else {
				j(value).val("");
			}
		}
	});
}

function autorivari(hint)
{
	var nomesharetbl = j(hint).attr('id').replace('autorivari','sharetbody');
	var inrow = j('#'+nomesharetbl).parents('tr:first').find('table tr:eq(3)');
	inrow.find('input[type="text"]:first').val('AA.VV.');
	inrow.find('input[type="text"]:not(:first)').val('');
	inrow.find('input[type="hidden"]:first').val('AA.VV.');
	inrow.find('img').attr('class','ds-authority-confidence cf-blank');
	var otherrow = inrow.parents('table:first').find('tr:not(:eq(3))');
	otherrow.find('input[type="text"]:first').val('');
	otherrow.find('input[type="text"]:not(:first)').val('');
	otherrow.find('input[type="hidden"]:first').val('');
	otherrow.find('img').attr('class','ds-authority-confidence cf-blank');
	return false;
}

function orderUpAndDown(fieldInput,fieldName,fieldPosition,fieldNewPosition) {

	  //autocomplete				  
	  var tmp_id = j("#id_" + fieldInput).val();
	  var tmp_prev_id = j("#id_" + fieldName + "_" + fieldNewPosition).val();
	  //element server
	  var tmp_server = j("#"+fieldInput).val();
	  var tmp_prev_server = j("#"+fieldName + "_" + fieldNewPosition).val();
	  //authority
	  var tmp_authority = j("#"+fieldName +"_authority_" + fieldPosition).val();
	  var tmp_prev_authority = j("#"+fieldName +"_authority_" + fieldNewPosition).val();
	  //confidence
	  var tmp_confidence = j("#"+fieldName +"_confidence_" + fieldPosition).val();
	  var tmp_prev_confidence = j("#"+fieldName +"_confidence_" + fieldNewPosition).val();
	  //confidence indicator
	  var tmp_confidence_indicator = j("#"+fieldInput +"_confidence_indicator_id").attr("class");
	  var tmp_prev_confidence_indicator = j("#"+fieldName + "_" + fieldNewPosition +"_confidence_indicator_id").attr("class");				  
	  //share
	  var tmp_share = j("#"+fieldName +"_share_" + fieldPosition).val();
	  var tmp_prev_share = j("#"+fieldName +"_share_" + fieldNewPosition).val();
	  //intorder
	  var tmp_intorder = j("#"+fieldName +"_intorder_" + fieldPosition).val();
	  var tmp_prev_intorder = j("#"+fieldName +"_intorder_" + fieldNewPosition).val();

	  //autocomplete				  
	  j("#id_" + fieldInput).val(tmp_prev_id);
	  j("#id_" + fieldName + "_" + fieldNewPosition).val(tmp_id);
	  //element server
	  j("#"+fieldInput).val(tmp_prev_server);
	  j("#"+fieldName + "_" + fieldNewPosition).val(tmp_server);
	  //authority
	  j("#"+fieldName +"_authority_" + fieldPosition).val(tmp_prev_authority);
	  j("#"+fieldName +"_authority_" + fieldNewPosition).val(tmp_authority);
	  //confidence
	  j("#"+fieldName +"_confidence_" + fieldPosition).val(tmp_prev_confidence);
	  j("#"+fieldName +"_confidence_" + fieldNewPosition).val(tmp_confidence);
	  //confidence indicator
	  j("#"+fieldInput +"_confidence_indicator_id").removeClass(tmp_confidence_indicator).addClass(tmp_prev_confidence_indicator);
	  j("#"+fieldName + "_" + fieldNewPosition +"_confidence_indicator_id").removeClass(tmp_prev_confidence_indicator).addClass(tmp_confidence_indicator);			  
	  //share
	  j("#"+fieldName +"_share_" + fieldPosition).val(tmp_prev_share);
	  j("#"+fieldName +"_share_" + fieldNewPosition).val(tmp_share);
	  //intorder
	  j("#"+fieldName +"_intorder_" + fieldPosition).val(tmp_prev_intorder);
	  j("#"+fieldName +"_intorder_" + fieldNewPosition).val(tmp_intorder);
}