GuiStateHandler = function (j, FormHandler) {

	
	
function GuiStateHandler() {
	
	var _private = {
		guiState : {},
		url : null,
		savedPreferences: [],
		preferences: null,
		menuForm : mkMenuForm("div[data-menu-name='cfg']"),
		viewName : "unknown",
		guiParts : {}
	}
	
	if(arguments.length > 0) {
		var theArgument = arguments[0];
		if ("string" === typeof (theArgument)) 
		{
			guiStateId = theArgument;
		} 
		else if ("object" === typeof (theArgument)) 
		{
			for( prop in _private )
			{
				if(prop in theArgument)
				{
					_private[prop] = theArgument[prop];
				}
			}
		}
	}
	
	if(arguments.length > 1) {
		_private.url = arguments[1];
	}
	
	if(arguments.length > 2) {
		_private.guiParts = arguments[2];
	}
	
	if(_private.guiState && _private.guiState.__bad__preferences) {
		_private.preferences = _private.guiState.__bad__preferences;
		_private.guiState.__bad__preferences = null;
	}
	
	_private.menuForm.getModel().allSavedPreferences = _private.savedPreferences;
	
	var self = this;
	j(document).ready(function() {
		
		handleStateSaving(self, _private.url);
		_private.menuForm.getInfo().guiStateHandler = self;
		_private.menuForm.init();
	});
	
	
	this.getGuiState = function GuiStateHandler__getGuiState() {
		if(!_private.guiState) {
			_private.guiState = {};
		}
		return _private.guiState;
	}
	
	this.setGuiState = function GuiStateHandler__setGuiState(newGuiState) {
		_private.guiState = newGuiState;
		this.applyStateToWindow();
	}
	
	this.getSavedCfgsNames = function GuiStateHandler__getSavedCfgsNames() {
		return _private.savedPreferences;
	}
	
	this.setSavedCfgList = function GuiStateHandler__setSavedCfgsNames( cfgsNames) {
		_private.savedPreferences = cfgsNames;
		_private.menuForm.getModel().allSavedPreferences = _private.savedPreferences;
		_private.menuForm.draw();
	}
	
	this.getPreferences = function GuiStateHandler__getPreferences() {
		return _private.preferences;
	}
	
	this.getUrl = function GuiStateHandler__getUrl() {
		return _private.url;
	}
	
	this.getViewName = function GuiStateHandler__getViewName() {
		return _private.viewName;
	}
	
	this.mergeLocalStateWithServerStateAndPreferences = function GuiStateHandler__mergeLocalStateWithServerStateAndPreferences(serverResponse, tableId) {
		if(!_private.preferences) {
			_private.preferences = {};
		}
		
		if(!_private.guiParts) {
			_private.guiParts = {};
		}
		
		for(var guiPart in _private.guiParts) {
			if(_private.guiParts.hasOwnProperty(guiPart)) {
				// - merge dello stato
				if(serverResponse && serverResponse.guiState && serverResponse.guiState[guiPart]) {
					_private.guiState[guiPart] = serverResponse.guiState[guiPart];
				}
				
				
				// - merge delle preferenze da una risposta che da tutte le preferenze
				if(!tableId) {
					if(serverResponse && serverResponse.preferences && serverResponse.preferences[guiPart]) {
						_private.preferences[guiPart] = serverResponse.preferences[guiPart];
					}
				} 
				
				// - merge delle preferenze di una sola parte della gui
				if(tableId == guiPart) {
					if(serverResponse && serverResponse.preferences) {
						_private.preferences[guiPart] = serverResponse.preferences;
					}
				}
			}
		}
	}

	this.getLoadTableStateFunction = function GuiStateHandler__getLoadTableStateFunction(idTable) {
		var self = this;
		return function loadState(oSettings, oData) {
			if (typeof idTable !== 'undefined'){
				localStorage.setItem( 'DataTables_'+idTable, JSON.stringify(oData) );
			}
			return GuiStateHandler__loadTableState(self, oSettings);
		};
	}
	
	this.getSaveTableStateFunction = function GuiStateHandler__getSaveTableStateFunction(idTable) {
		var self = this;
		if (typeof idTable !== 'undefined' && localStorage.getItem('DataTables_'+idTable) != 'undefined'){
			oData = JSON.parse( localStorage.getItem('DataTables_'+idTable) );
		}
		//oData = JSON.parse( localStorage.getItem('DataTables_'+window.location.pathname) );
		return function saveTableState(oSettings, oData) {
			var tableId = oSettings.sTableId; 
			var guiState = self.getGuiState();
			guiState[tableId] = oData;
			if (typeof idTable !== 'undefined'){
				guiState[idTable] = oData;
			}
		};
	}
}
	

GuiStateHandler.prototype.applyStateToWindow = function GuiStateHandler__applyStateToWindowr() {
	location.reload();
} 

function handleStateSaving(guiStateHandler, url) {
	
	j(window).on('beforeunload', function(){
		var guiState = guiStateHandler.getGuiState();
		if(guiState) {
			j.ajax( {
				"url": url,
				"data": { 
					guiState: JSON.stringify(guiState),
					viewName: guiStateHandler.getViewName()
				},
				"dataType": "json",
				"method": "POST",
				"async": false,
				"success": function () {}
			} );
		}
	});
}



function mkMenuForm(selector) {
	var form = new FormHandler({
		selector: selector,
		actions: {
			"reset" : function(menuForm, params, el, evt) {
				var guiStateHandler = menuForm.getInfo().guiStateHandler;
				var url = guiStateHandler.getUrl();
				var tableId = params.tableid;
				j.ajax( {
					"url": url,
					"data": {
						cmd: "reset",
						guiPartId: tableId,
						viewName : guiStateHandler.getViewName()
					},
					"dataType": "json",
					"method": "POST",
					"success": function (json) 
					{
						if(json && !json.error)
						{
							var guiState = guiStateHandler.getGuiState(); 
							guiStateHandler.mergeLocalStateWithServerStateAndPreferences(json, tableId);
							var preferences = guiStateHandler.getPreferences();
							guiState.__bad__preferences = preferences;
							window.location.reload();
						} else {
							alert("SERVER COMUNICATION ERROR");
						}
					}
				} );
			},
			"load" : function(menuForm, params, el, evt) {
				var guiStateHandler = menuForm.getInfo().guiStateHandler;
				var url = guiStateHandler.getUrl();
				var cfgId = params.id;
				var tableId = params.tableid;
				j.ajax( {
					"url": url,
					"data": {
						cmd: "loadpref",
						prefName: cfgId,
						guiPartId: tableId,
						viewName : guiStateHandler.getViewName()
					},
					"dataType": "json",
					"method": "POST",
					"success": function (json) 
					{
						if(json && !json.error)
						{
							var guiState = guiStateHandler.getGuiState(); 
							guiStateHandler.mergeLocalStateWithServerStateAndPreferences(json, tableId);
							var preferences = guiStateHandler.getPreferences();
							guiState.__bad__preferences = preferences;
							window.location.reload();
						} else {
							alert("SERVER COMUNICATION ERROR");
						}
					},
					complete: function (xhr, status) {
							console.log(status);
					}
				} );
			},
			"remove" : function(menuForm, params, el, evt) {
				var guiStateHandler = menuForm.getInfo().guiStateHandler;
				var url = guiStateHandler.getUrl();
				var cfgId = params.id;
				var tableId = params.tableid;
				j.ajax( {
					"url": url,
					"data": {
						cmd: "remove",
						prefName: cfgId,
						guiPartId: tableId,
						viewName : guiStateHandler.getViewName()
					},
					"dataType": "json",
					"method": "POST",
					"success": function (json) 
					{
						if(json && !json.error) {
							guiStateHandler.setSavedCfgList(json.savedPreferences);
						} else {
							alert("SERVER COMUNICATION ERROR");
						}
					}
				} );
			},
			"open-save" : function(menuForm, params, el, evt) {
				var guiStateHandler = menuForm.getInfo().guiStateHandler;
				var url = guiStateHandler.getUrl();
				var cfgId = params.cfgId;
				var modalTableId = params.tableid;
				
				if(!menuForm.getInfo().saveCfgDialog) {
				
					menuForm.getInfo().saveCfgDialog = jQuery('#saveForm').modal();
					var saveCfgDialog = menuForm.getInfo().saveCfgDialog;
					
					saveCfgDialog.find("[data-action='ok']").on('click', function () {
						var formEl = saveCfgDialog.find('form');
						var name = formEl.find('#cfgName').val();
						var mkDefault = formEl.find('#mkDefault').prop('checked');
						if(name) {
							name = name.replace(/^\s+|\s+$/gm,'');
						}
						if(name) {
							var guiState = guiStateHandler.getGuiState();
							var tablePreferences = GuiStateHandler__extractTablePreferencies(guiState, modalTableId);
							
							j.ajax( {
								"url": url,
								"data": { 
									cmd: "persist",
									mkDefault: mkDefault,
									guiPref: JSON.stringify(tablePreferences),
									prefName: name,
									guiPartId : modalTableId,
									viewName : guiStateHandler.getViewName()
								},
								"dataType": "json",
								"method": "POST",
								"async": false,
								"success": function (json) 
								{
									if(json && !json.error) {
										guiStateHandler.setSavedCfgList(json.savedPreferences);
									} else {
										alert("SERVER COMUNICATION ERROR");
									}
									
									//addMessage("success", true, "guistate_cfgsavedmsg");
									jQuery('#saveForm').modal("hide");
								}
							} );
							saveCfgDialog.modal( "hide" );
						} else {
							alert(getTextMessage('saveFormNameRequired'));
						}
					
					});
					
					saveCfgDialog.find("[data-action='cancel']").on('click', function () {
						saveCfgDialog.modal( "hide" );
					});
				} else {
					menuForm.getInfo().saveCfgDialog.modal( "show");
				};
				
				var inputEl = j('#cfgName');
				inputEl.autocomplete({
					minLength: 0,
					source: function(input, callback) {
						cfgNamesAutocomplete(modalTableId, input, callback)
					}
				});
			}
		},
		defaultAction : function(menuForm, params, el, evt) {
			
		},
		model : {},
		info : {}
	}); 
	
	function cfgNamesAutocomplete(tableId, input, callback) {
		var userInput = input.term;
		
		var allCfgsNames = form.getModel().allSavedPreferences;
		
		var options = [];
		if(allCfgsNames && allCfgsNames[tableId]) {
			var cfgs = allCfgsNames[tableId];
			var cfgsLength = cfgs.length;
			for(var i=0; i<cfgsLength; i++) {
				var nameNow = cfgs[i];
				if(nameNow.indexOf(userInput) == 0) {
					options.push(nameNow);
				}
			}
		}
		callback(options);
	}
	
	return form;
};
	

function GuiStateHandler__extractTablePreferencies(guiState, tableId) {
	var tablePreferences;
	
	if(guiState && guiState[tableId]) {
		var tbl = jQuery('#'+tableId).dataTable();
		var tblState =  guiState[tableId];
		
		var tblSettings = tbl.fnSettings();
		
		// Utilizzare i data name anziche gli indici delle colonne ed estrarre:
		//  - filtro
		//  - colonna per la quale si è ordinato asc/desc
		//  - elenco completo delle colonne il cui ordine vale anche come ordine di reordering
		//  - colonne nascoste
		
		//console.log(tbl, tblState, tblSettings);
		
		//console.log("table: ", tableId);
		
		var colsNames = [];
		for(var i=0; i<tblSettings.aoColumns.length; i++) {
			var column = tblSettings.aoColumns[i];
			var name = column.mData;
			colsNames.push(name);
		}
		//console.log("all columns", colsNames);
		
		var hiddenColsNames = [];
		for(var i=0; i<tblState.abVisCols.length; i++) {
			if(!tblState.abVisCols[i]) {
				var originalIdx =  i;
				if(tblState.ColReorder) {
					var newIdx = tblState.ColReorder.indexOf(i);
					if(newIdx>=0) {
						originalIdx  = newIdx;
					}
				}
				hiddenColsNames.push(tblSettings.aoColumns[originalIdx].mData);
			}
		}
		//console.log("hidden cols", tblState.abVisCols, hiddenColsNames);
		
		var sortingCols = [];
		for(var i=0; i<tblState.aaSorting.length; i++) {
			var colData = tblState.aaSorting[i];
			var colIdx = colData[0]; 
			var ascending = (colData[2]==0) ? true : false;  
			var originalIdx =  colIdx;
			if(tblState.ColReorder) {
				var newIdx = tblState.ColReorder.indexOf(colIdx);
				if(newIdx>=0) {
					originalIdx  = newIdx;
				}
			}
			var colName = tblSettings.aoColumns[originalIdx].mData;
			sortingCols.push({ colName: colName, ascending: ascending});
		}
		//console.log("sorting by:", sortingCols);
		
		
		var searchCols = [];
		for(var i=0; i<tblState.aoSearchCols.length; i++) {
			var colData = tblState.aoSearchCols[i];
			var colIdx = i; 
			var value = colData.sSearch;
			if(value) {
				var originalIdx =  colIdx;
				if(tblState.ColReorder) {
					var newIdx = tblState.ColReorder.indexOf(i);
					if(newIdx>=0) {
						originalIdx  = newIdx;
					}
				}
				var colName = tblSettings.aoColumns[originalIdx].mData;
				searchCols.push({ colName: colName, filter: value});
			}
			
		}
		
		tablePreferences = {
			filter: tblState.oSearch.sSearch,
			columnsFilters: searchCols,
			columns: colsNames,
			hidden: hiddenColsNames,
			sortInf: sortingCols,
			pageLength : tblState.iLength
		};
	} else {
		tablePreferences = null;
	}
	return tablePreferences;
}


function GuiStateHandler__loadTableState(guiStateHandler, oSettings ) {
	var result = null;
	var tableId = oSettings.sTableId;
	
	function getColumnPosition(colName) {
		var columns = oSettings.oInit.aoColumns;
		for(var i=0; i<columns.length; i++) {
			var column = columns[i];
			if(column && colName == column.mData) {
				return i;
			}
		}
		return -1;
	}
	
	function countingArray(number) {
		var result = [];
		for(var i=0; i<number; i++) {
			result.push(i);
		}
		return result;
	}
	
	function constantArray(length, value) {
		var result = [];
		for(var i=0; i<length; i++) {
			result.push(value);
		}
		return result;
	}
	
	var guiState = guiStateHandler.getGuiState();
	var allPreferencies = guiStateHandler.getPreferences();
			
	var tablePreferences;
	if(allPreferencies && allPreferencies[tableId]) {
		tablePreferences = allPreferencies[tableId];
	} else {
		tablePreferences = null;
	}
	
	if(!guiState) {
		guiState = { };
	}
	
	if(!guiState[tableId]) {
		guiState[tableId] = { };
	}
	var tableState = guiState[tableId];
	
	if(tablePreferences) {
		
		if(!tableState.oSearch) {
			tableState.oSearch = {};
		}
		
		
		//console.log("ripristino stato "+tableId, oSettings, tableState, tableState.persisted);
		
		// - ripristino filtraggio
		tableState.oSearch.sSearch = tablePreferences.filter;
		
		// - ripristino dimensione pagina 
		tableState.iLength = tablePreferences.pageLength;
		
		
		// - ripristino ordinamento colonne e loro visibilità
		if(!tableState.ColReorder) {
			tableState.ColReorder = countingArray(oSettings.oInit.aoColumns.length);
		}
		if(!tableState.abVisCols) {
			tableState.abVisCols = constantArray(oSettings.oInit.aoColumns.length, true);
		}
		if(tablePreferences.columns) {
			for(var i=tablePreferences.columns.length-1; i>=0; i--) {
				var colName = tablePreferences.columns[i];
				var colPos = getColumnPosition(colName);
				
				//console.log("colonna: "+colName+" trovata in "+colPos);
				
				if(colPos>=0) {
					var tmp = tableState.ColReorder.indexOf(colPos);
					tableState.ColReorder.splice(tmp, 1);
					tableState.ColReorder.unshift(colPos);
					
					if(tablePreferences.hidden.indexOf(colName)>=0) {
						tableState.abVisCols[colPos] = false;
						//console.log("colonna: "+colName+" hide");
					} else {
						tableState.abVisCols[colPos] = true;
						//console.log("colonna: "+colName+" show");
					}
				} else {
					tableState.abVisCols[colPos] = false;
					//console.log("colonna: "+colName+" hide");
				}
				
			}
		}
		
		// - drop filters on columns
		if(tableState && tableState.aoSearchCols) {
			for(var i=0; i<tableState.aoSearchCols.length; i++) {
				var colSearchInfo = tableState.aoSearchCols[i];
				if(colSearchInfo) {
					colSearchInfo.sSearch = "";
				}
			}
		}
		
		// - put new columns filters if needed
		if(tablePreferences.columnsFilters) {
			for(var i=tablePreferences.columnsFilters.length-1; i>=0; i--) {
				var colName = tablePreferences.columnsFilters[i].colName;
				var colPos = getColumnPosition(colName);
				var colFilter = tablePreferences.columnsFilters[i].filter;
				
				console.log("colonna "+colName+" ("+colPos+") filtro "+colFilter);
				
				if(colPos>=0) {
					if(!tableState.aoSearchCols) {
						tableState.aoSearchCols = [];
					}
					
					if(!tableState.aoSearchCols[colPos]) {
						tableState.aoSearchCols[colPos] = {};
					}
					
					tableState.aoSearchCols[colPos].sSearch = colFilter; 
				}
			}
		}
		
		
		// - ripristino ordinamento dei dati
		if(!tableState.aaSorting) {
			tableState.aaSorting = [];
		}
		// - Se devo mettere un nuovo ordinamento allora elimino quello vecchio
		var persistedSortInfo = tablePreferences.sortInf; 
		if( persistedSortInfo && persistedSortInfo.length>0) {
			tableState.aaSorting = [];
			
			for(var i=0; i<persistedSortInfo.length; i++) {
				var sordInfo = persistedSortInfo[i];
				var colName = sordInfo.colName;
				var colPos = getColumnPosition(colName);
				
				if(colPos>=0) {
					var newSorting = [
						colPos, 
						(sordInfo.ascending) ? "asc" : "desc",
						(sordInfo.ascending) ? 0 : 1
					];
					tableState.aaSorting.push(newSorting);
					//console.log("adding sorting: ", newSorting);
				}
			}
		}
				
		allPreferencies[tableId] = null;
	}
	else {
		if(!tableState.aaSorting) {
			tableState.aaSorting = [];
		}
		if(!tableState.abVisCols) {
			tableState.abVisCols = constantArray(oSettings.oInit.aoColumns.length, true);
		}
	}
	result = (tableState) ? tableState : null;
	return result;
};

return GuiStateHandler;	
}(jQuery, FormHandler);

