FilterDialogHandler = (function () {

//var dialogBodyTemplate = "<div>pannello di filtraggio</div>"

function getTextMessage(msgKey) {
	var msgTemplate = j('#'+msgKey);
	var msgText = msgTemplate.text();
	return msgText;
}


function updateForm(selector, templateModel) {
	jQuery(selector).find('*[data-template]').each( function(idx, el) {
		var jEl = j(el);
		var templateId = jEl.attr('data-template');
		var templateHtmlResult = tmpl(templateId, templateModel);
		jEl.html(templateHtmlResult);
	});
	
}

function getColumnPosition(table, colName) {
	var columns = table.fnSettings().oInit.aoColumns;
	for(var i=0; i<columns.length; i++) {
		var column = columns[i];
		if(column && colName == column.mData) {
			return i;
		}
	}
	return -1;
}


function setFilters(filterDataArray, table, guiStateHandler) {
	var tableSettings = table.fnSettings();
	var tableId = tableSettings.sTableId;
	
	var tableState = null;
	var guiState = guiStateHandler.getGuiState();
	if(guiState) {
		tableState = guiState[tableId];
	}
	
	for(var i=0; i<filterDataArray.length; i++) {
		var filterInfo = filterDataArray[i];
		var colIdx = getColumnPosition(table, filterInfo.name);
		if(tableState && tableState.ColReorder) {
			var newIdx = tableState.ColReorder.indexOf(colIdx);
			if(newIdx>=0) {
				colIdx  = newIdx;
			}
		}
		if(colIdx>=0) {
			table.fnFilter(filterInfo.value, colIdx);
		} else {
			alert("colonna "+filterInfo.name+" non trovata");
		}
	}
}

function FilterDialogHandler(selector, filterInfoUrl, guiStateHandler) {
	var currentTable = null;
	
	var filterDialog = null;
	
	
	
	function FilterDialogHandler_initDialog() {
		filterDialog = jQuery(selector).modal({
			//modal:true,
		}); 
		
		jQuery(selector).find("[data-action='ok']").on('click', function () {
			var filterData = jQuery(selector).find('form').serializeArray();
			setFilters(filterData, currentTable, guiStateHandler);
			filterDialog.modal( "hide" );
		});
	}
	
	this.openDialog = function FilterDialogHandler__openDialog(table) {
		currentTable = table;
		var tableSettings = table.fnSettings();
		var tableId = tableSettings.sTableId;
		jQuery.ajax({
			"dataType": 'json',
            "type": "POST",
            "data" : [{
            	"name": "tableId",
            	"value": tableId 
            }],
            "url": filterInfoUrl,
            "error": function(data){
            	if (!mydspaceData.error)
            	{
            		mydspaceData.error = true;
            		alert('error');
            	}
            },
            "success": function (json) {
            	if (json == null || json.error)
            	{
            		if (!mydspaceData.error)
                	{
            			mydspaceData.error = true;
            			alert('error');
                	}		
            	} else {
            		var formModel = { collectionsTree: json.result.data, filters: {} };
            		formModel.tableId = tableId;
            		
            		// - Update form model from table's columns filtering state
            		if(guiStateHandler) {
            			var guiState = guiStateHandler.getGuiState();
            			
            			var tableState = guiState[tableId];
            			
            			if(tableState && tableState.aoSearchCols) {
            				for(var i=0; i<tableState.aoSearchCols.length; i++) {
                        		var colFilterInfo = tableState.aoSearchCols[i];
                        		if(colFilterInfo && colFilterInfo.sSearch) {
                        			var colIdx =  i;
                    				var colName = table.fnSettings().oInit.aoColumns[colIdx].mData;
                        			formModel.filters[""+colName] = colFilterInfo.sSearch;
                        		}
                        	}
            			}
            		}
            		
            		updateForm(selector, formModel);
            		if(!filterDialog) {
            			FilterDialogHandler_initDialog();
            		} else {
            			filterDialog.modal("show");
            		}
            	}
            }
		});
	};
}
	
return FilterDialogHandler;	
})();
